#include <sys/types.h>
#include <sys/socket.h>


/**
   Send a block (composition of: type, size of datablock and
   datablock (buf)) to a socket. WARNING: The integers (type and
   size; excluding fd) are only 16 bit values (0 - 65535).

   @param fd (int) descriptor of the socket to which buf should send

   @param type (unsigned int) This value can be used as buyer's option

   @param buf (char *) which should be send

   @return number of sent bytes, -1 if an error is occurt.
*/

int block_send(int fd, unsigned int type, char *buf,
	       unsigned int size) {
  // add up the number of sent byte, for checking.
  int i, r;

  // send the type of the data
  i = r = 0;
  while (r < 2) {
    if ((i = send(fd, (void *) &type + r, 2 - r, 0)) < 0) {
      return -1;
    }
    r += i;
  }
  // send the size of the buffer
  i = r = 0;
  while (r < 2) {
    if ((i = send(fd, (void *) &size + r, 2 - r, 0)) < 0) {
      return -1;
    }
    r += i;
  }
  // send the data in the buffer it self
  i = r = 0;
  while (r < size) {
    if ((i = send(fd, (void *) buf + r, size - r, 0)) < 0) {
      return -1;
    }
    r += i;
  }

  /*
  // send the type of the data
  if ((r = send(fd, (void *) &type, 2, 0)) < 0) {
    return -1;
  }
  // send the size of the buffer
  if ((i = send(fd, (void *) &size, 2, 0)) < 0) {
    perror("send0()");
    return -1;
  }
  r += i;
  // send the data in the buffer it self
  if ((i = send(fd, buf, size, 0)) < 0) {
    perror("send1()");
    return -1;
  }
  r += i;

  // not the comlete messages was sent.
  if (r = (size + 4)) {
    perror("send2()");
    return -1;
  }
  */

  return r;
}
